package eu.mhsl.craftattack.spawn.appliances.infoBars;

import eu.mhsl.craftattack.spawn.appliance.ApplianceCommand;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;

public class InfoBarCommand extends ApplianceCommand.PlayerChecked<InfoBars> {
    public InfoBarCommand() {
        super("infobar");
    }

    @Override
    protected void execute(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) throws Exception {
        if(args.length == 0) throw new Error("<show|hide|hideall> [bar name]");
        switch(args[0]) {
            case "hideAll" -> getAppliance().hideAll(getPlayer());
            case "show" -> getAppliance().show(getPlayer(), args[1]);
            case "hide" -> getAppliance().hide(getPlayer(), args[1]);
            default -> throw new Error("Erlaubte Optionen sind 'show', 'hide', 'hideAll'!");
        }
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if(args.length == 1) return List.of("show", "hide", "hideAll");
        return getAppliance().getInfoBars().stream().map(Bar::name).toList();
    }
}
